<template>
     <ObForm
        :form-data="formData"
        :form-model="formModel"
        :is-read-only="!isNew"
        @submit="onSubmitHandler"
        :dropdown-menu="dropdownMenu"
        class="temperature-transportation-form"
    >
        <div class="row">
            <div class="col-xs-6">
                <ob-input
                    :label="dictionaryRu.modal.denomination"
                    :placeholder="dictionaryRu.modal.denomination_placeholder"
                    v-model="formData.denomination"
                    :disabled="!isNew"
                    property="denomination"
                />
            </div>
            <div class="col-xs-6">
                <ob-select
                    :disabled="!isNew"
                    :remote-opt="getTemperatureModeTypes"
                    v-model="formData.mode_type"
                    :label="dictionaryRu.modal.mode_type"
                />
            </div>
        </div>

        <div class="row">
            <div class="col-xs-6">
                {{ dictionaryRu.modal.normal_mode }}
            </div>
            <div class="col-xs-6">
                {{ dictionaryRu.modal.critical_mode }}
            </div>
        </div>
        <div class="row">
            <div class="col-xs-3">
                <ob-input
                    :label="dictionaryRu.modal.min_temperature"
                    :placeholder="dictionaryRu.modal.min_temperature"
                    typ="number"
                    v-model="formData.temperature_low_limit"
                    :disabled="!isNew"
                    property="min_temperature"
                />
            </div>
            <div class="col-xs-3">
                <ob-input
                    :label="dictionaryRu.modal.max_temperature"
                    :placeholder="dictionaryRu.modal.max_temperature"
                    v-model="formData.temperature_high_limit"
                    :disabled="!isNew"
                    property="temperature_high_limit"
                />
            </div>
            <div class="col-xs-3">
                <ob-input
                    :label="dictionaryRu.modal.min_temperature"
                    :placeholder="dictionaryRu.modal.min_temperature"
                    v-model="formData.critical_deviation_low_limit"
                    :disabled="!isNew"
                    property="critical_deviation_low_limit"
                />
            </div>
            <div class="col-xs-3">
                <ob-input
                    :label="dictionaryRu.modal.max_temperature"
                    :placeholder="dictionaryRu.modal.max_temperature"
                    v-model="formData.critical_deviation_high_limit"
                    :disabled="!isNew"
                    property="critical_deviation_high_limit"
                />
            </div>
        </div>


        <div class="row">
            <div class="col-xs-12">
                <div class="ob-input-container">
                    <ob-textarea
                        :label="dictionaryRu.modal.description"
                        v-model="formData.description"
                        :placeholder="dictionaryRu.modal.description_placeholder"
                        :disabled="!isNew"
                        property="description"
                    />
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-xs-6">
                <ob-input
                    :disabled="!isNew"
                    :label="dictionaryRu.modal.single_max_time_out_of_borders"
                    v-model="formData.single_max_time_out_of_borders"
                    property="single_max_time_out_of_borders"
                />
            </div>
            <div class="col-xs-6">
                <ob-select
                    :label="dictionaryRu.modal.temperature_recorders"
                    :is-multiselect="true"
                    :is-tagbox="true"
                    :is-dropdown="true"
                    :items="filteredTemperatureRecorders"
                    v-model="formData.temperature_recorders"
                    property="temperature_recorders"
                    :placeholder="dictionaryRu.modal.temperature_recorders_placeholder"
                    display-exp="denomination"
                    value-exp="uuid"
                    :disabled="!isNew"
                />
            </div>
        </div>
        <div class="row">
            <div class="col-xs-6">
                <ob-input
                    :disabled="!isNew"
                    :label="dictionaryRu.modal.sum_max_time_out_of_borders"
                    v-model="formData.sum_max_time_out_of_borders"
                    property="sum_max_time_out_of_borders"
                />
            </div>
        </div>
    </ObForm>
</template>

<script>
    import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
    import models from '@/models';
    import cloneDeep from 'clone-deep';
    import ObForm from "common-components/src/obComponents/obForm";
    import ObInput from "common-components/src/obComponents/obInput";
    import ObSelect from "common-components/src/obComponents/obSelect";
    import ObTextarea from "common-components/src/obComponents/obTextarea";
    import dropdownEvents from '@/mixins/dictionaries/dropdown-events';
    import api from '@/api'
    import { TEMPERATURE_MODE_ICONS_BY_NAME } from '@/resources/enum';
    import { dictionary } from '@/translations/ru/dictionaries__temperature__temperature_transportation_modes'

    export default {
        name: "TemperatureTransportationMode",
        components: {
            ObTextarea,
            ObSelect,
            ObInput,
            ObForm
        },
        mixins: [
            FormValidationMixin,
            dropdownEvents
        ],
        props: {
            temperatureRecorders: {
                type: Array,
                required: true,
                default: () => []
            },
            dataSource: {
                type: Object,
                required: true,
                default: () => {}
            }
        },
        computed: {
            formModel () {
                return models.temperatureTransportationModes.add;
            },
            isNew () {
                return !this.formData.uuid;
            },
            filteredTemperatureRecorders () {
                if (this.isNew) {
                    return this.temperatureRecorders.filter(record => {
                        return !record.deleted_at
                    })
                }
                return this.temperatureRecorders
            }
        },
        data() {
            return {
                slider: null,
                rangeTemperature: [],
                isInit: false,
                dictionaryRu: dictionary
            }
        },
        watch: {
            rangeTemperature() {
                if (!this.isInit) return;

                if (this.rangeTemperature[0] || this.rangeTemperature[0] == 0) {
                    this.formData.temperature_low_limit = this.rangeTemperature[0];
                }

                if (this.rangeTemperature[1] || this.rangeTemperature[1] == 0) {
                    this.formData.temperature_high_limit = this.rangeTemperature[1];
                }
            },
            'formData.temperature_low_limit'() {
                if (!this.isInit) return;

                if(this.formData.critical_deviation_low_limit > this.formData.temperature_low_limit) {
                    this.formData.critical_deviation_low_limit = this.formData.temperature_low_limit;
                }
                this.slider.set([this.formData.critical_deviation_low_limit,
                    this.formData.temperature_low_limit,
                    this.formData.temperature_high_limit,
                    this.formData.critical_deviation_high_limit]);
            },
            'formData.uuid'() {
                if (!this.isInit) return;

                let origins = this.$refs.criticalTemperature.getElementsByClassName('noUi-origin');
                if(!this.isNew) {
                    origins[0].setAttribute('disabled', true);
                    origins[3].setAttribute('disabled', true);
                    this.$refs.criticalTemperature.setAttribute('disabled', true);
                }
                else {
                    origins[0].removeAttribute('disabled');
                    origins[3].removeAttribute('disabled');
                    this.$refs.criticalTemperature.removeAttribute('disabled');
                }
            },
            'formData.temperature_high_limit'() {
                if (!this.isInit) return;

                if(this.formData.critical_deviation_high_limit < this.formData.temperature_high_limit) {
                    this.formData.critical_deviation_high_limit = this.formData.temperature_high_limit;
                }
                this.slider.set([
                    this.formData.critical_deviation_low_limit,
                    this.formData.temperature_low_limit,
                    this.formData.temperature_high_limit,
                    this.formData.critical_deviation_high_limit
                ]);
            },
            ['parentModal.visible'] (value) {
                if (!value) {
                    this.formData = {};
                    this.rangeTemperature = [];
                }
            }
        },
        methods: {
            onSubmitHandler () {
                const data = cloneDeep(this.formData);

                this.$emit('submit', { formData: data, model: this.formModel })
            },
            async getTemperatureModeTypes () {
                try {
                    let list = await api.temperature.getTemperatureModeTypes()
                    return list.map((item) => {
                        return {
                            ...item,
                            icon: TEMPERATURE_MODE_ICONS_BY_NAME[item.title.toLowerCase()] || false
                        }
                    })
                } catch (e) {
                    this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных' })
                    return []
                }
            }
        }
    }
</script>

<style lang="scss">
.temperature-transportation-form {
    .noUi-target {
        background: $temperatureTransportationPage-ObForm-noUi_target_background;
        margin-top: 15px;
        height: 2px;
        border: none;
    }
    .noUi-connect {
        background: $temperatureTransportationPage-ObForm-noUi_connect_background;
    }
    .noUi-handle {
        border: none;
        border-radius: 0;
        background: none;
        box-shadow: none;
        width: 0;
        height: 0;
        &::before {
            margin-top: -6px;
            margin-left: -37px;
            width: 12px;
            height: 12px;
            background: $temperatureTransportationPage-ObForm-noUi_handle_background_before;
            border-radius: 50%;
        }
        &::after {
            width: 0;
            height: 0;
        }
        .noUi-touch-area {
            display: none;
        }
    }
    .noUi-active {
        &:focus { outline: none; }
    }
}
</style>
